1061-按字典序排列最小的等效字符串

Raphael Liu Lv10

给出长度相同的两个字符串s1s2 ,还有一个字符串 baseStr

其中 s1[i]s2[i] 是一组等价字符。

  • 举个例子,如果 s1 = "abc"s2 = "cde",那么就有 'a' == 'c', 'b' == 'd', 'c' == 'e'

等价字符遵循任何等价关系的一般规则:

  • ** 自反性 **:'a' == 'a'
  • **对称性 **:'a' == 'b' 则必定有 'b' == 'a'
  • 传递性'a' == 'b''b' == 'c' 就表明 'a' == 'c'

例如, s1 = "abc"s2 = "cde" 的等价信息和之前的例子一样,那么 baseStr = "eed" , "acd"
"aab",这三个字符串都是等价的,而 "aab"baseStr 的按字典序最小的等价字符串

利用 _ _s1s2 的等价信息,找出并返回 _ _baseStr _ _ 的按字典序排列最小的等价字符串。

示例 1:

**输入:** s1 = "parker", s2 = "morris", baseStr = "parser"
**输出:** "makkek"
**解释:** 根据 A 和 B 中的等价信息,我们可以将这些字符分为 [m,p], [a,o], [k,r,s], [e,i] 共 4 组。每组中的字符都是等价的,并按字典序排列。所以答案是 "makkek"。

示例 2:

**输入:** s1 = "hello", s2 = "world", baseStr = "hold"
**输出:** "hdld"
**解释:** 根据 A 和 B 中的等价信息,我们可以将这些字符分为 [h,w], [d,e,o], [l,r] 共 3 组。所以只有 S 中的第二个字符 'o' 变成 'd',最后答案为 "hdld"。

示例 3:

**输入:** s1 = "leetcode", s2 = "programs", baseStr = "sourcecode"
**输出:** "aauaaaaada"
**解释:** 我们可以把 A 和 B 中的等价字符分为 [a,o,e,r,s,c], [l,p], [g,t] 和 [d,m] 共 4 组,因此 S 中除了 'u' 和 'd' 之外的所有字母都转化成了 'a',最后答案为 "aauaaaaada"。

提示:

  • 1 <= s1.length, s2.length, baseStr <= 1000
  • s1.length == s2.length
  • 字符串s1, s2, and baseStr 仅由从 'a''z' 的小写英文字母组成。

解题思路

本题是典型的并查集应用题,一个字符可以与多个字符等价,很容易联想到并查集的union,本题我们将‘a’-“z”26个字符,可以转化为0-25这26个数字。
由于题目要求:将baseStr转化为字典序最小的等价字符串;那么我们需要在union方法中做一个改造,使得等价的两个字符union时,根节点指向字典序更小的那个字符。

1
2
3
4
5
if (pRoot < qRoot) {
parent[qRoot] = pRoot;
} else {
parent[pRoot] = qRoot;
}

解题步骤:

  1. 改造UF的union方法,使得等价的两个字符union时,根节点指向字典序更小的那个字符;
  2. 同时遍历s1、s2,将等价的字符相连;
  3. 遍历baseStr,找到每个字符的根,并用sb组合;
  4. 返回结果。

代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
class Solution {
public String smallestEquivalentString(String s1, String s2, String baseStr) {
int n = s1.length();
char[] chs1 = s1.toCharArray();
char[] chs2 = s2.toCharArray();
UF uf = new UF(26);
for (int i = 0; i < n; i++) {
char ch1 = chs1[i];
char ch2 = chs2[i];
uf.union(ch1 - 'a', ch2 - 'a');
}
StringBuilder sb = new StringBuilder();
char[] baseStrArr = baseStr.toCharArray();
for (char c : baseStrArr) {
char nc = (char) (uf.findRoot(c - 'a') + 'a');
sb.append(nc);
}
return sb.toString();
}

class UF {
private int[] parent;
private int count;

public UF(int n) {
parent = new int[n];
for (int i = 0; i < n; i++) {
parent[i] = i;
}
count = n;
}

public int findRoot(int x) {
while(parent[x] != x) {
parent[x] = parent[parent[x]];
x = parent[x];
}
return x;
}

public boolean connected(int p, int q) {
int pRoot = findRoot(p);
int qRoot = findRoot(q);
return pRoot == qRoot;
}

public void union(int p, int q) {
int pRoot = findRoot(p);
int qRoot = findRoot(q);
if (pRoot == qRoot) {
return;
}
if (pRoot < qRoot) {
parent[qRoot] = pRoot;
} else {
parent[pRoot] = qRoot;
}
--count;
}

public int getCount() {
return count;
}
}
}

image.png
如果您认可道哥的题解,麻烦点赞支持一下。

 Comments
On this page
1061-按字典序排列最小的等效字符串